unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus ;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    T: TLabel;
    OpenDlg: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure OpenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  AppPath : String ;
  ILGFile : String ;
  ILGPath : String ;
  DataBin : TStringList ;

procedure TForm1.FormCreate(Sender: TObject);
begin

//  Get and store home directory
  AppPath := ExtractFilePath(Application.ExeName);
  Edit1.Text := '' ;
  Button1.Enabled := False ;

end;

procedure TForm1.OpenClick(Sender: TObject);
var
   PathStr : String ;
   SaveStr : String ;
begin
  Edit1.Text := '' ;
  OpenDlg.InitialDir := AppPath ;
  OpenDlg.Filter := 'Text files (*.txt)|*.txt' ;
  if OpenDlg.Execute = True then
    begin
      PathStr := OpenDlg.FileName ;
      ILGPath := ExtractFilePath( PathStr ) ;
      ILGFile := ExtractFileName ( PathStr ) ;
      DataBin.Clear ;
      DataBin.LoadFromFile( PathStr ) ;
      If StrLen( PAnsiChar(DataBin[0]) ) <> 297 then
        begin
           DataBin.Clear ;
           ShowMessage( 'The specified file is not in the old ILGRadio format.  Try again, or quit.' ) ;
           exit ;
        end ;
      SaveStr := ILGPath + 'ReFormatILG.bak' ;
      DataBin.SaveToFile( SaveStr );
      Edit1.Text := ILGFile + ' is loaded.  Click the ''Convert'' button to begin.' ;
      Button1.Enabled := True ;
    end ;

end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  DataBin.Clear ;
  close ;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i, Conv : Integer ;
  InStr, TmpStr : String ;
  OutBin : TStringList ;
begin

  Edit1.Text := '' ;

  if DataBin.Count = 0 then
    begin
      ShowMessage( 'Nothing to convert...' ) ;
      exit ;
    end ;

  OutBin := TStringList.Create ;
  OutBin.Clear ;

  Conv := 0 ;
  for i := 0 to (DataBin.Count - 1) do
    begin

      InStr := DataBin[ i ] ;
      if StrLen( PAnsiChar(DataBin[i]) ) <> 297 then
        continue ;

      Inc( Conv ) ;

      //  Freq
      TmpStr := Copy( InStr, 1, 7 ) + '0' ;
      //  Station
      TmpStr := TmpStr + Copy( Instr, 8, 22 ) ;
      //  UTC
      TmpStr := TmpStr + Copy( Instr, 30, 9 ) ;
      //  Days
      TmpStr := TmpStr + Copy( Instr, 39, 7 ) ;
      //  Language
      TmpStr := TmpStr + Copy( Instr, 46, 17 ) ;
      //  Graphic
      TmpStr := TmpStr + Copy( Instr, 64, 48 ) ;
      //  Target
      TmpStr := TmpStr + Copy( Instr, 112, 8 ) ;
      //  Location
      TmpStr := TmpStr + Copy( Instr, 120, 25 ) ;
      //  Power
      TmpStr := TmpStr + ' ' + Copy( Instr, 145, 7 ) ;
      //  Azi
      TmpStr := TmpStr + Copy( Instr, 152, 3 ) ;
      //  Remarks
      TmpStr := TmpStr + Copy( Instr, 155, 15 ) ;
      //  Status
      TmpStr := TmpStr + Copy( Instr, 197, 1 ) ;
      //  Mod
      TmpStr := TmpStr + Copy( Instr, 170, 1 ) ;
      //  NA-PA:  18 char.
      TmpStr := TmpStr + Copy( Instr, 171, 18 ) ;
      //  CIRAF
      TmpStr := TmpStr + Copy( Instr, 189, 30 ) ;
      //  Adm
      TmpStr := TmpStr + Copy( Instr, 224, 3 ) ;
      //  Country
      TmpStr := TmpStr + Copy( Instr, 227, 18 ) ;
      //  Longitude
      TmpStr := TmpStr + Copy( Instr, 245, 6 ) ;
      //  Latitude
      TmpStr := TmpStr + Copy( Instr, 251, 5 ) ;
      //  LC
      TmpStr := TmpStr + '  ' ;
      //  Region
      TmpStr := TmpStr + Copy( Instr, 256, 20 ) ;
      //  Stn
      TmpStr := TmpStr + Copy( Instr, 219, 5 ) ;
      //  P
      TmpStr := TmpStr + Copy( Instr, 276, 1 ) ;
      //  Program
      TmpStr := TmpStr + Copy( Instr, 277, 20 ) ;

      Outbin.Add( TmpStr ) ;

    end ;

  OutBin.SaveToFile( ILGPath + ILGFile );

  OutBin.Clear ;
  Databin.Clear ;
  OutBin.Free ;

  Edit1.Text := 'Your file has been successfully converted - ' + IntToStr( Conv ) + ' records.' ;
  Button1.Enabled := False ;
  
end;

initialization

   DataBin := TStringList.Create ;


finalization

   Databin.Free ;



end.



